Index: pjproject/trunk/build.symbian/bld.inf
===================================================================
--- pjproject/trunk/build.symbian/bld.inf	(revision 1615)
+++ pjproject/trunk/build.symbian/bld.inf	(revision 1640)
@@ -6,10 +6,9 @@
 prj_mmpfiles
 pjlib.mmp
-//pjlib_test.mmp
 pjlib_util.mmp
 pjnath.mmp
 pjsdp.mmp
 null_audio.mmp
-symbian_ua.mmp
+symbian_audio.mmp
 pjmedia.mmp
 pjsip.mmp
@@ -17,2 +16,6 @@
 pjsip_ua.mmp
 pjsua_lib.mmp
+
+pjlib_test.mmp
+symbian_ua.mmp
+symsndtest.mmp
Index: pjproject/trunk/build.symbian/null_audio.mmp
===================================================================
--- pjproject/trunk/build.symbian/null_audio.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/null_audio.mmp	(revision 1640)
@@ -1,7 +1,8 @@
-#if defined(EKA2)
+#if defined(PJ_BUILD_DLL)
 
 TARGET		null_audio.dll
 TARGETTYPE	dll
-UID		0x1000008d 0xA0004294
+UID		0x0 0xA0000000
+
 
 CAPABILITY	None
@@ -16,6 +17,4 @@
 TARGET 		null_audio.lib
 TARGETTYPE 	lib
-UID		0x100039CE 0x10004299
-VENDORID	0x70000001
 
 #endif
Index: pjproject/trunk/build.symbian/pjlib.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjlib.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/pjlib.mmp	(revision 1640)
@@ -1,7 +1,7 @@
-#if defined(EKA2)
-// ARM ABIv2 doesn't support static libraries anymore
+#if defined(PJ_BUILD_DLL)
 TARGET		pjlib.dll
 TARGETTYPE	dll
-UID		0x1000008d 0xA0004299
+UID		0x0 0xA0000001
+
 CAPABILITY	NONE
 LIBRARY		esock.lib insock.lib charconv.lib euser.lib estlib.lib
@@ -15,6 +15,5 @@
 TARGET 		pjlib.lib
 TARGETTYPE 	lib
-UID		0x100039CE 0x10004299
-//VENDORID	0x70000001
+
 #endif
 
Index: pjproject/trunk/build.symbian/pjlib_test.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjlib_test.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/pjlib_test.mmp	(revision 1640)
@@ -1,6 +1,6 @@
 TARGET 		pjlib_test.exe
 TARGETTYPE 	exe
-UID		0x100039CE 0x10004299
-VENDORID	0x70000001
+UID		0x0 0xA0000002
+
 
 SOURCEPATH	..\pjlib\src\pjlib-test
@@ -9,6 +9,9 @@
 MACRO		PJ_SYMBIAN=1
 
-#if defined(EKA2)
+#if defined(PJ_BUILD_DLL)
 MACRO		PJ_DLL
+LIBRARY		pjlib.lib 
+#else
+STATICLIBRARY	pjlib.lib 
 #endif
 
@@ -58,6 +61,7 @@
 SYSTEMINCLUDE	\epoc32\include\libc
 
-LIBRARY		pjlib.lib esock.lib insock.lib charconv.lib euser.lib estlib.lib eexe.lib
-STATICLIBRARY   ecrt0.lib
-CAPABILITY	None
+LIBRARY		esock.lib insock.lib charconv.lib euser.lib estlib.lib 
+#ifdef WINSCW
+STATICLIBRARY   eexe.lib ecrt0.lib
+#endif
 
Index: pjproject/trunk/build.symbian/pjlib_util.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjlib_util.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/pjlib_util.mmp	(revision 1640)
@@ -1,6 +1,7 @@
-#if defined(EKA2)
+#if defined(PJ_BUILD_DLL)
 TARGET		pjlib_util.dll
 TARGETTYPE	dll
-UID		0x1000008d 0xA0004298
+UID		0x0 0xA0000003
+
 CAPABILITY	NONE
 LIBRARY		pjlib.lib esock.lib insock.lib charconv.lib euser.lib estlib.lib
@@ -11,8 +12,7 @@
 
 #else
+
 TARGET 		pjlib_util.lib
 TARGETTYPE 	lib
-UID		0x100039CE 0x10004299
-//VENDORID	0x70000001
 
 #endif
Index: pjproject/trunk/build.symbian/pjmedia.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjmedia.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/pjmedia.mmp	(revision 1640)
@@ -1,7 +1,8 @@
-#if defined(EKA2)
+#if defined(PJ_BUILD_DLL)
 
 TARGET		pjmedia.dll
 TARGETTYPE	dll
-UID		0x1000008d 0xA0004295
+UID		0x0 0xA0000004
+
 CAPABILITY	None
 LIBRARY		null_audio.lib pjsdp.lib pjnath.lib pjlib_util.lib pjlib.lib esock.lib insock.lib charconv.lib euser.lib estlib.lib
@@ -15,6 +16,4 @@
 TARGET 		pjmedia.lib
 TARGETTYPE 	lib
-UID		0x100039CE 0x10004299
-VENDORID	0x70000001
 
 #endif
Index: pjproject/trunk/build.symbian/pjnath.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjnath.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/pjnath.mmp	(revision 1640)
@@ -1,6 +1,7 @@
-#if defined(EKA2)
+#if defined(PJ_BUILD_DLL)
 TARGET		pjnath.dll
 TARGETTYPE	dll
-UID		0x1000008d 0xA0004297
+UID		0x0 0xA0000005
+
 CAPABILITY	None
 LIBRARY		pjlib_util.lib pjlib.lib esock.lib insock.lib charconv.lib euser.lib estlib.lib
@@ -14,6 +15,4 @@
 TARGET 		pjnath.lib
 TARGETTYPE 	lib
-UID		0x100039CE 0x10004299
-VENDORID	0x70000001
 
 #endif
@@ -64,5 +63,2 @@
 SYSTEMINCLUDE	\epoc32\include\libc
 
-//STATICLIBRARY		pjlib.lib 
-//STATICLIBRARY		pjlib_util.lib 
-
Index: pjproject/trunk/build.symbian/pjsdp.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjsdp.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/pjsdp.mmp	(revision 1640)
@@ -1,6 +1,7 @@
-#if defined(EKA2)
+#if defined(PJ_BUILD_DLL)
 TARGET		pjsdp.dll
 TARGETTYPE	dll
-UID		0x1000008d 0xA0004296
+UID		0x0 0xA0000006
+
 CAPABILITY	None
 LIBRARY		pjlib_util.lib pjlib.lib charconv.lib euser.lib estlib.lib
@@ -14,6 +15,4 @@
 TARGET 		pjsdp.lib
 TARGETTYPE 	lib
-UID		0x100039CE 0x10004299
-VENDORID	0x70000001
 
 #endif
Index: pjproject/trunk/build.symbian/pjsip.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjsip.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/pjsip.mmp	(revision 1640)
@@ -1,8 +1,9 @@
-#if defined(EKA2)
+#if defined(PJ_BUILD_DLL)
 
 TARGET		pjsip.dll
 TARGETTYPE	dll
 
-UID		0x1000008d 0xA0004293
+UID		0x0 0xA0000007
+
 
 CAPABILITY	None
@@ -17,6 +18,4 @@
 TARGET 		pjsip.lib
 TARGETTYPE 	lib
-UID		0x100039CE 0x10004299
-VENDORID	0x70000001
 
 #endif
Index: pjproject/trunk/build.symbian/pjsip_simple.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjsip_simple.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/pjsip_simple.mmp	(revision 1640)
@@ -1,8 +1,9 @@
-#if defined(EKA2)
+#if defined(PJ_BUILD_DLL)
 
 TARGET		pjsip_simple.dll
 TARGETTYPE	dll
 
-UID		0x1000008d 0xA0004292
+UID		0x0 0xA0000008
+
 
 CAPABILITY	None
@@ -17,6 +18,4 @@
 TARGET 		pjsip_simple.lib
 TARGETTYPE 	lib
-UID		0x100039CE 0x10004299
-VENDORID	0x70000001
 
 #endif
Index: pjproject/trunk/build.symbian/pjsip_ua.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjsip_ua.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/pjsip_ua.mmp	(revision 1640)
@@ -1,8 +1,9 @@
-#if defined(EKA2)
+#if defined(PJ_BUILD_DLL)
 
 TARGET		pjsip_ua.dll
 TARGETTYPE	dll
 
-UID		0x1000008d 0xA0004291
+UID		0x0 0xA0000009
+
 
 CAPABILITY	None
@@ -17,6 +18,4 @@
 TARGET 		pjsip_ua.lib
 TARGETTYPE 	lib
-UID		0x100039CE 0x10004299
-VENDORID	0x70000001
 
 #endif
Index: pjproject/trunk/build.symbian/pjstun_client.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjstun_client.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/pjstun_client.mmp	(revision 1640)
@@ -1,6 +1,5 @@
 TARGET 		pjstun_client.exe
 TARGETTYPE 	exe
-UID		0x100039CE 0x10004299
-VENDORID	0x70000001
+UID		0x0 0xA000000A
 
 SOURCEPATH	..\pjnath\src\pjstun-client
@@ -27,6 +26,18 @@
 SYSTEMINCLUDE	\epoc32\include\libc
 
-LIBRARY		pjnath.lib pjlib_util.lib pjlib.lib esock.lib insock.lib charconv.lib euser.lib estlib.lib eexe.lib
-STATICLIBRARY   ecrt0.lib
+#if defined(PJ_BUILD_DLL)
+MACRO		PJ_DLL
+LIBRARY		pjnath.lib pjlib_util.lib pjlib.lib
+#else
+STATICLIBRARY	pjnath.lib pjlib_util.lib pjlib.lib
+#endif
+
+LIBRARY		esock.lib insock.lib charconv.lib euser.lib estlib.lib
+
+#ifdef WINSCW
+STATICLIBRARY   eexe.lib ecrt0.lib
+#endif
+
+
 CAPABILITY	None
 
Index: pjproject/trunk/build.symbian/pjsua_lib.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjsua_lib.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/pjsua_lib.mmp	(revision 1640)
@@ -1,8 +1,9 @@
-#if defined(EKA2)
+#if defined(PJ_BUILD_DLL)
 
 TARGET		pjsua_lib.dll
 TARGETTYPE	dll
 
-UID		0x1000008d 0xA0004290
+UID		0x0 0xA000000B 
+
 
 CAPABILITY	None
@@ -17,6 +18,4 @@
 TARGET 		pjsua_lib.lib
 TARGETTYPE 	lib
-UID		0x100039CE 0x10004299
-VENDORID	0x70000001
 
 #endif
Index: pjproject/trunk/build.symbian/symbian_audio.mmp
===================================================================
--- pjproject/trunk/build.symbian/symbian_audio.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/symbian_audio.mmp	(revision 1640)
@@ -1,7 +1,7 @@
-#if defined(EKA2)
+#if defined(PJ_BUILD_DLL)
 
 TARGET		symbian_audio.dll
 TARGETTYPE	dll
-UID		0x1000008d 0xA0004288
+UID		0x0 0xA000000C
 
 CAPABILITY	None
@@ -19,6 +19,4 @@
 TARGET 		symbian_audio.lib
 TARGETTYPE 	lib
-UID		0x100039CE 0x10004288
-VENDORID	0x70000001
 
 #endif
Index: pjproject/trunk/build.symbian/symbian_ua.mmp
===================================================================
--- pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 1640)
@@ -1,6 +1,5 @@
 TARGET 		symbian_ua.exe
 TARGETTYPE 	exe
-UID		0x100039CE 0x10004289
-VENDORID	0x70000001
+UID		0x0 0xA000000D
 
 SOURCEPATH	..\pjsip-apps\src\symbian_ua
@@ -8,7 +7,10 @@
 MACRO		PJ_M_I386=1
 MACRO		PJ_SYMBIAN=1
-MACRO		PJ_DLL=1
 
-// Test files
+#if defined(PJ_BUILD_DLL)
+	MACRO		PJ_DLL=1
+#endif
+
+// Source files
 
 SOURCE	ua.cpp
@@ -26,6 +28,28 @@
 SYSTEMINCLUDE	\epoc32\include\libc
 
-LIBRARY		esock.lib insock.lib charconv.lib euser.lib estlib.lib eexe.lib
-LIBRARY		null_audio.lib pjsua_lib.lib pjsip_ua.lib pjsip_simple.lib pjsip.lib pjsdp.lib pjmedia.lib pjnath.lib pjlib_util.lib pjlib.lib ecrt0.lib
-CAPABILITY	None
+#if defined(PJ_BUILD_DLL)
+	LIBRARY		pjsua_lib.lib pjsip_ua.lib
+	LIBRARY		pjsip_simple.lib pjsip.lib pjsdp.lib pjmedia.lib
+	LIBRARY		pjnath.lib pjlib_util.lib pjlib.lib
+	LIBRARY		symbian_audio.lib
+#else
+	STATICLIBRARY	pjsua_lib.lib pjsip_ua.lib
+	STATICLIBRARY	pjsip_simple.lib pjsip.lib pjsdp.lib pjmedia.lib
+	STATICLIBRARY	pjnath.lib pjlib_util.lib pjlib.lib
+	STATICLIBRARY	symbian_audio.lib
+#endif
 
+#ifdef WINSCW
+	STATICLIBRARY   eexe.lib ecrt0.lib
+#endif
+
+LIBRARY		esock.lib insock.lib charconv.lib euser.lib estlib.lib 
+LIBRARY 	mediaclientaudiostream.lib
+LIBRARY 	mediaclientaudioinputstream.lib
+
+CAPABILITY	NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment 
+
+START RESOURCE  symbian_ua_reg.rss
+	TARGETPATH      \private\10003a3f\apps
+END
+
Index: pjproject/trunk/build.symbian/symbian_ua.pkg
===================================================================
--- pjproject/trunk/build.symbian/symbian_ua.pkg	(revision 1640)
+++ pjproject/trunk/build.symbian/symbian_ua.pkg	(revision 1640)
@@ -0,0 +1,18 @@
+; symbian_ua.pkg
+
+; Languages
+&EN
+
+; Header
+#{"symbian_ua"},(0xA000000E), 0, 1, 1
+
+; Platform compatibility
+[0x101F7961], *, *, *,{"Series60ProductID"}
+
+; vendor
+%{"PJSIP"}
+:"PJSIP"
+
+; Target
+"C:\Symbian\9.1\S60_3rd_MR\epoc32\release\gcce\UDEB\symbian_ua.exe"-"!:\sys\bin\symbian_ua.exe"
+"C:\Symbian\9.1\S60_3rd_MR\epoc32\data\z\private\10003a3f\apps\symbian_ua_reg.rSC"-"!:\private\10003a3f\import\apps\symbian_ua_reg.rSC"
Index: pjproject/trunk/build.symbian/symsndtest.mmp
===================================================================
--- pjproject/trunk/build.symbian/symsndtest.mmp	(revision 1615)
+++ pjproject/trunk/build.symbian/symsndtest.mmp	(revision 1640)
@@ -1,6 +1,5 @@
 TARGET 		symsndtest.exe
 TARGETTYPE 	exe
-UID		0x100039CE 0x10004287
-VENDORID	0x70000001
+UID		0x0 0xA000000E
 
 SOURCEPATH	..\pjsip-apps\src\symsndtest
@@ -8,5 +7,8 @@
 MACRO		PJ_M_I386=1
 MACRO		PJ_SYMBIAN=1
-MACRO		PJ_DLL=1
+
+#if defined(PJ_BUILD_DLL)
+	MACRO		PJ_DLL=1
+#endif
 
 // Test files
@@ -21,6 +23,24 @@
 SYSTEMINCLUDE	\epoc32\include\libc
 
-LIBRARY		charconv.lib euser.lib estlib.lib eexe.lib
-LIBRARY		symbian_audio.lib pjlib.lib ecrt0.lib
-CAPABILITY	None
+LIBRARY		charconv.lib euser.lib estlib.lib
 
+#if defined(PJ_BUILD_DLL)
+	LIBRARY		symbian_audio.lib pjlib.lib 
+#else
+	STATICLIBRARY	symbian_audio.lib pjlib.lib 
+#endif
+
+LIBRARY		esock.lib insock.lib
+LIBRARY 	mediaclientaudiostream.lib
+LIBRARY 	mediaclientaudioinputstream.lib
+
+#ifdef WINSCW
+	STATICLIBRARY   eexe.lib ecrt0.lib
+#endif
+
+CAPABILITY	NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment 
+
+START RESOURCE  symsndtest_reg.rss
+	TARGETPATH	\private\10003a3f\apps
+END
+
Index: pjproject/trunk/build.symbian/symsndtest.pkg
===================================================================
--- pjproject/trunk/build.symbian/symsndtest.pkg	(revision 1640)
+++ pjproject/trunk/build.symbian/symsndtest.pkg	(revision 1640)
@@ -0,0 +1,19 @@
+; symsndtest.pkg
+
+; Languages
+&EN
+
+; Header
+#{"symsndtest"},(0xA000000F), 0, 1, 1
+
+; Platform compatibility
+[0x101F7961], *, *, *, {"Series60ProductID"}
+
+; vendor
+%{"PJSIP"}
+:"PJSIP"
+
+; Target
+"C:\Symbian\9.1\S60_3rd_MR\Epoc32\release\gcce\UDEB\symsndtest.exe"-"!:\sys\bin\symsndtest.exe"
+"C:\Symbian\9.1\S60_3rd_MR\Epoc32\data\z\private\10003a3f\apps\symsndtest_reg.rSC"-"!:\private\10003a3f\import\apps\symsndtest_reg.rSC"
+