Index: pjproject/trunk/build.symbian/pjlibU.def
===================================================================
--- pjproject/trunk/build.symbian/pjlibU.def	(revision 1658)
+++ pjproject/trunk/build.symbian/pjlibU.def	(revision 1664)
@@ -283,38 +283,41 @@
 	pj_symbianos_poll                        @ 282 NONAME
 	pj_symbianos_set_params                  @ 283 NONAME
-	pj_thread_create                         @ 284 NONAME
-	pj_thread_destroy                        @ 285 NONAME
-	pj_thread_get_name                       @ 286 NONAME
-	pj_thread_get_os_handle                  @ 287 NONAME
-	pj_thread_is_registered                  @ 288 NONAME
-	pj_thread_join                           @ 289 NONAME
-	pj_thread_local_alloc                    @ 290 NONAME
-	pj_thread_local_free                     @ 291 NONAME
-	pj_thread_local_get                      @ 292 NONAME
-	pj_thread_local_set                      @ 293 NONAME
-	pj_thread_register                       @ 294 NONAME
-	pj_thread_resume                         @ 295 NONAME
-	pj_thread_sleep                          @ 296 NONAME
-	pj_thread_this                           @ 297 NONAME
-	pj_time_decode                           @ 298 NONAME
-	pj_time_encode                           @ 299 NONAME
-	pj_time_gmt_to_local                     @ 300 NONAME
-	pj_time_local_to_gmt                     @ 301 NONAME
-	pj_time_val_normalize                    @ 302 NONAME
-	pj_timer_entry_init                      @ 303 NONAME
-	pj_timer_heap_cancel                     @ 304 NONAME
-	pj_timer_heap_count                      @ 305 NONAME
-	pj_timer_heap_create                     @ 306 NONAME
-	pj_timer_heap_destroy                    @ 307 NONAME
-	pj_timer_heap_earliest_time              @ 308 NONAME
-	pj_timer_heap_mem_size                   @ 309 NONAME
-	pj_timer_heap_poll                       @ 310 NONAME
-	pj_timer_heap_schedule                   @ 311 NONAME
-	pj_timer_heap_set_lock                   @ 312 NONAME
-	pj_timer_heap_set_max_timed_out_per_poll @ 313 NONAME
-	pj_unicode_to_ansi                       @ 314 NONAME
-	pj_utoa                                  @ 315 NONAME
-	pj_utoa_pad                              @ 316 NONAME
-	platform_strerror                        @ 317 NONAME
-	snprintf                                 @ 318 NONAME
-	vsnprintf                                @ 319 NONAME
+	pj_thread_check_stack                    @ 284 NONAME
+	pj_thread_create                         @ 285 NONAME
+	pj_thread_destroy                        @ 286 NONAME
+	pj_thread_get_name                       @ 287 NONAME
+	pj_thread_get_os_handle                  @ 288 NONAME
+	pj_thread_get_stack_info                 @ 289 NONAME
+	pj_thread_get_stack_max_usage            @ 290 NONAME
+	pj_thread_is_registered                  @ 291 NONAME
+	pj_thread_join                           @ 292 NONAME
+	pj_thread_local_alloc                    @ 293 NONAME
+	pj_thread_local_free                     @ 294 NONAME
+	pj_thread_local_get                      @ 295 NONAME
+	pj_thread_local_set                      @ 296 NONAME
+	pj_thread_register                       @ 297 NONAME
+	pj_thread_resume                         @ 298 NONAME
+	pj_thread_sleep                          @ 299 NONAME
+	pj_thread_this                           @ 300 NONAME
+	pj_time_decode                           @ 301 NONAME
+	pj_time_encode                           @ 302 NONAME
+	pj_time_gmt_to_local                     @ 303 NONAME
+	pj_time_local_to_gmt                     @ 304 NONAME
+	pj_time_val_normalize                    @ 305 NONAME
+	pj_timer_entry_init                      @ 306 NONAME
+	pj_timer_heap_cancel                     @ 307 NONAME
+	pj_timer_heap_count                      @ 308 NONAME
+	pj_timer_heap_create                     @ 309 NONAME
+	pj_timer_heap_destroy                    @ 310 NONAME
+	pj_timer_heap_earliest_time              @ 311 NONAME
+	pj_timer_heap_mem_size                   @ 312 NONAME
+	pj_timer_heap_poll                       @ 313 NONAME
+	pj_timer_heap_schedule                   @ 314 NONAME
+	pj_timer_heap_set_lock                   @ 315 NONAME
+	pj_timer_heap_set_max_timed_out_per_poll @ 316 NONAME
+	pj_unicode_to_ansi                       @ 317 NONAME
+	pj_utoa                                  @ 318 NONAME
+	pj_utoa_pad                              @ 319 NONAME
+	platform_strerror                        @ 320 NONAME
+	snprintf                                 @ 321 NONAME
+	vsnprintf                                @ 322 NONAME
Index: pjproject/trunk/build.symbian/pjmedia.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjmedia.mmp	(revision 1658)
+++ pjproject/trunk/build.symbian/pjmedia.mmp	(revision 1664)
@@ -41,4 +41,5 @@
 SOURCE		endpoint.c
 SOURCE		errno.c
+SOURCE		delaybuf.c
 SOURCE		g711.c
 SOURCE		jbuf.c
Index: pjproject/trunk/build.symbian/pjmediaU.def
===================================================================
--- pjproject/trunk/build.symbian/pjmediaU.def	(revision 1658)
+++ pjproject/trunk/build.symbian/pjmediaU.def	(revision 1664)
@@ -43,148 +43,151 @@
 	pjmedia_conf_remove_port                 @ 42 NONAME
 	pjmedia_conf_set_port0_name              @ 43 NONAME
-	pjmedia_echo_cancel                      @ 44 NONAME
-	pjmedia_echo_capture                     @ 45 NONAME
-	pjmedia_echo_create                      @ 46 NONAME
-	pjmedia_echo_destroy                     @ 47 NONAME
-	pjmedia_echo_playback                    @ 48 NONAME
-	pjmedia_echo_port_create                 @ 49 NONAME
-	pjmedia_endpt_create                     @ 50 NONAME
-	pjmedia_endpt_create_pool                @ 51 NONAME
-	pjmedia_endpt_create_sdp                 @ 52 NONAME
-	pjmedia_endpt_destroy                    @ 53 NONAME
-	pjmedia_endpt_dump                       @ 54 NONAME
-	pjmedia_endpt_get_codec_mgr              @ 55 NONAME
-	pjmedia_endpt_get_ioqueue                @ 56 NONAME
-	pjmedia_endpt_get_thread                 @ 57 NONAME
-	pjmedia_endpt_get_thread_count           @ 58 NONAME
-	pjmedia_ice_create                       @ 59 NONAME
-	pjmedia_ice_destroy                      @ 60 NONAME
-	pjmedia_ice_get_comp                     @ 61 NONAME
-	pjmedia_ice_get_init_status              @ 62 NONAME
-	pjmedia_ice_init_ice                     @ 63 NONAME
-	pjmedia_ice_modify_sdp                   @ 64 NONAME
-	pjmedia_ice_simulate_lost                @ 65 NONAME
-	pjmedia_ice_start_ice                    @ 66 NONAME
-	pjmedia_ice_start_init                   @ 67 NONAME
-	pjmedia_ice_stop_ice                     @ 68 NONAME
-	pjmedia_jbuf_create                      @ 69 NONAME
-	pjmedia_jbuf_destroy                     @ 70 NONAME
-	pjmedia_jbuf_get_frame                   @ 71 NONAME
-	pjmedia_jbuf_get_state                   @ 72 NONAME
-	pjmedia_jbuf_put_frame                   @ 73 NONAME
-	pjmedia_jbuf_reset                       @ 74 NONAME
-	pjmedia_jbuf_set_adaptive                @ 75 NONAME
-	pjmedia_jbuf_set_fixed                   @ 76 NONAME
-	pjmedia_master_port_create               @ 77 NONAME
-	pjmedia_master_port_destroy              @ 78 NONAME
-	pjmedia_master_port_get_dport            @ 79 NONAME
-	pjmedia_master_port_get_uport            @ 80 NONAME
-	pjmedia_master_port_set_dport            @ 81 NONAME
-	pjmedia_master_port_set_uport            @ 82 NONAME
-	pjmedia_master_port_start                @ 83 NONAME
-	pjmedia_master_port_stop                 @ 84 NONAME
-	pjmedia_mem_capture_create               @ 85 NONAME
-	pjmedia_mem_capture_get_size             @ 86 NONAME
-	pjmedia_mem_capture_set_eof_cb           @ 87 NONAME
-	pjmedia_mem_player_create                @ 88 NONAME
-	pjmedia_mem_player_set_eof_cb            @ 89 NONAME
-	pjmedia_null_port_create                 @ 90 NONAME
-	pjmedia_plc_create                       @ 91 NONAME
-	pjmedia_plc_generate                     @ 92 NONAME
-	pjmedia_plc_save                         @ 93 NONAME
-	pjmedia_port_destroy                     @ 94 NONAME
-	pjmedia_port_get_frame                   @ 95 NONAME
-	pjmedia_port_info_init                   @ 96 NONAME
-	pjmedia_port_put_frame                   @ 97 NONAME
-	pjmedia_resample_create                  @ 98 NONAME
-	pjmedia_resample_destroy                 @ 99 NONAME
-	pjmedia_resample_get_input_size          @ 100 NONAME
-	pjmedia_resample_port_create             @ 101 NONAME
-	pjmedia_resample_run                     @ 102 NONAME
-	pjmedia_rtcp_build_rtcp                  @ 103 NONAME
-	pjmedia_rtcp_fini                        @ 104 NONAME
-	pjmedia_rtcp_get_ntp_time                @ 105 NONAME
-	pjmedia_rtcp_init                        @ 106 NONAME
-	pjmedia_rtcp_rx_rtcp                     @ 107 NONAME
-	pjmedia_rtcp_rx_rtp                      @ 108 NONAME
-	pjmedia_rtcp_tx_rtp                      @ 109 NONAME
-	pjmedia_rtp_decode_rtp                   @ 110 NONAME
-	pjmedia_rtp_encode_rtp                   @ 111 NONAME
-	pjmedia_rtp_session_init                 @ 112 NONAME
-	pjmedia_rtp_session_update               @ 113 NONAME
-	pjmedia_session_check_dtmf               @ 114 NONAME
-	pjmedia_session_create                   @ 115 NONAME
-	pjmedia_session_destroy                  @ 116 NONAME
-	pjmedia_session_dial_dtmf                @ 117 NONAME
-	pjmedia_session_enum_streams             @ 118 NONAME
-	pjmedia_session_get_dtmf                 @ 119 NONAME
-	pjmedia_session_get_info                 @ 120 NONAME
-	pjmedia_session_get_port                 @ 121 NONAME
-	pjmedia_session_get_stream_stat          @ 122 NONAME
-	pjmedia_session_info_from_sdp            @ 123 NONAME
-	pjmedia_session_pause                    @ 124 NONAME
-	pjmedia_session_pause_stream             @ 125 NONAME
-	pjmedia_session_resume                   @ 126 NONAME
-	pjmedia_session_resume_stream            @ 127 NONAME
-	pjmedia_session_set_dtmf_callback        @ 128 NONAME
-	pjmedia_silence_det_apply                @ 129 NONAME
-	pjmedia_silence_det_create               @ 130 NONAME
-	pjmedia_silence_det_detect               @ 131 NONAME
-	pjmedia_silence_det_disable              @ 132 NONAME
-	pjmedia_silence_det_set_adaptive         @ 133 NONAME
-	pjmedia_silence_det_set_fixed            @ 134 NONAME
-	pjmedia_silence_det_set_name             @ 135 NONAME
-	pjmedia_silence_det_set_params           @ 136 NONAME
-	pjmedia_snd_port_connect                 @ 137 NONAME
-	pjmedia_snd_port_create                  @ 138 NONAME
-	pjmedia_snd_port_create_player           @ 139 NONAME
-	pjmedia_snd_port_create_rec              @ 140 NONAME
-	pjmedia_snd_port_destroy                 @ 141 NONAME
-	pjmedia_snd_port_disconnect              @ 142 NONAME
-	pjmedia_snd_port_get_ec_tail             @ 143 NONAME
-	pjmedia_snd_port_get_port                @ 144 NONAME
-	pjmedia_snd_port_get_snd_stream          @ 145 NONAME
-	pjmedia_snd_port_set_ec                  @ 146 NONAME
-	pjmedia_splitcomb_create                 @ 147 NONAME
-	pjmedia_splitcomb_create_rev_channel     @ 148 NONAME
-	pjmedia_splitcomb_set_channel            @ 149 NONAME
-	pjmedia_stream_check_dtmf                @ 150 NONAME
-	pjmedia_stream_create                    @ 151 NONAME
-	pjmedia_stream_destroy                   @ 152 NONAME
-	pjmedia_stream_dial_dtmf                 @ 153 NONAME
-	pjmedia_stream_get_dtmf                  @ 154 NONAME
-	pjmedia_stream_get_port                  @ 155 NONAME
-	pjmedia_stream_get_stat                  @ 156 NONAME
-	pjmedia_stream_get_transport             @ 157 NONAME
-	pjmedia_stream_info_from_sdp             @ 158 NONAME
-	pjmedia_stream_pause                     @ 159 NONAME
-	pjmedia_stream_resume                    @ 160 NONAME
-	pjmedia_stream_set_dtmf_callback         @ 161 NONAME
-	pjmedia_stream_start                     @ 162 NONAME
-	pjmedia_strerror                         @ 163 NONAME
-	pjmedia_tonegen_create                   @ 164 NONAME
-	pjmedia_tonegen_create2                  @ 165 NONAME
-	pjmedia_tonegen_get_digit_map            @ 166 NONAME
-	pjmedia_tonegen_is_busy                  @ 167 NONAME
-	pjmedia_tonegen_play                     @ 168 NONAME
-	pjmedia_tonegen_play_digits              @ 169 NONAME
-	pjmedia_tonegen_set_digit_map            @ 170 NONAME
-	pjmedia_tonegen_stop                     @ 171 NONAME
-	pjmedia_transport_udp_attach             @ 172 NONAME
-	pjmedia_transport_udp_close              @ 173 NONAME
-	pjmedia_transport_udp_create             @ 174 NONAME
-	pjmedia_transport_udp_create2            @ 175 NONAME
-	pjmedia_transport_udp_create3            @ 176 NONAME
-	pjmedia_transport_udp_get_info           @ 177 NONAME
-	pjmedia_transport_udp_simulate_lost      @ 178 NONAME
-	pjmedia_wav_player_port_create           @ 179 NONAME
-	pjmedia_wav_player_port_get_pos          @ 180 NONAME
-	pjmedia_wav_player_port_set_pos          @ 181 NONAME
-	pjmedia_wav_player_set_eof_cb            @ 182 NONAME
-	pjmedia_wav_playlist_create              @ 183 NONAME
-	pjmedia_wav_playlist_set_eof_cb          @ 184 NONAME
-	pjmedia_wav_writer_port_create           @ 185 NONAME
-	pjmedia_wav_writer_port_get_pos          @ 186 NONAME
-	pjmedia_wav_writer_port_set_cb           @ 187 NONAME
-	pjmedia_wave_hdr_file_to_host            @ 188 NONAME
-	pjmedia_wave_hdr_host_to_file            @ 189 NONAME
+	pjmedia_delay_buf_create                 @ 44 NONAME
+	pjmedia_delay_buf_get                    @ 45 NONAME
+	pjmedia_delay_buf_put                    @ 46 NONAME
+	pjmedia_echo_cancel                      @ 47 NONAME
+	pjmedia_echo_capture                     @ 48 NONAME
+	pjmedia_echo_create                      @ 49 NONAME
+	pjmedia_echo_destroy                     @ 50 NONAME
+	pjmedia_echo_playback                    @ 51 NONAME
+	pjmedia_echo_port_create                 @ 52 NONAME
+	pjmedia_endpt_create                     @ 53 NONAME
+	pjmedia_endpt_create_pool                @ 54 NONAME
+	pjmedia_endpt_create_sdp                 @ 55 NONAME
+	pjmedia_endpt_destroy                    @ 56 NONAME
+	pjmedia_endpt_dump                       @ 57 NONAME
+	pjmedia_endpt_get_codec_mgr              @ 58 NONAME
+	pjmedia_endpt_get_ioqueue                @ 59 NONAME
+	pjmedia_endpt_get_thread                 @ 60 NONAME
+	pjmedia_endpt_get_thread_count           @ 61 NONAME
+	pjmedia_ice_create                       @ 62 NONAME
+	pjmedia_ice_destroy                      @ 63 NONAME
+	pjmedia_ice_get_comp                     @ 64 NONAME
+	pjmedia_ice_get_init_status              @ 65 NONAME
+	pjmedia_ice_init_ice                     @ 66 NONAME
+	pjmedia_ice_modify_sdp                   @ 67 NONAME
+	pjmedia_ice_simulate_lost                @ 68 NONAME
+	pjmedia_ice_start_ice                    @ 69 NONAME
+	pjmedia_ice_start_init                   @ 70 NONAME
+	pjmedia_ice_stop_ice                     @ 71 NONAME
+	pjmedia_jbuf_create                      @ 72 NONAME
+	pjmedia_jbuf_destroy                     @ 73 NONAME
+	pjmedia_jbuf_get_frame                   @ 74 NONAME
+	pjmedia_jbuf_get_state                   @ 75 NONAME
+	pjmedia_jbuf_put_frame                   @ 76 NONAME
+	pjmedia_jbuf_reset                       @ 77 NONAME
+	pjmedia_jbuf_set_adaptive                @ 78 NONAME
+	pjmedia_jbuf_set_fixed                   @ 79 NONAME
+	pjmedia_master_port_create               @ 80 NONAME
+	pjmedia_master_port_destroy              @ 81 NONAME
+	pjmedia_master_port_get_dport            @ 82 NONAME
+	pjmedia_master_port_get_uport            @ 83 NONAME
+	pjmedia_master_port_set_dport            @ 84 NONAME
+	pjmedia_master_port_set_uport            @ 85 NONAME
+	pjmedia_master_port_start                @ 86 NONAME
+	pjmedia_master_port_stop                 @ 87 NONAME
+	pjmedia_mem_capture_create               @ 88 NONAME
+	pjmedia_mem_capture_get_size             @ 89 NONAME
+	pjmedia_mem_capture_set_eof_cb           @ 90 NONAME
+	pjmedia_mem_player_create                @ 91 NONAME
+	pjmedia_mem_player_set_eof_cb            @ 92 NONAME
+	pjmedia_null_port_create                 @ 93 NONAME
+	pjmedia_plc_create                       @ 94 NONAME
+	pjmedia_plc_generate                     @ 95 NONAME
+	pjmedia_plc_save                         @ 96 NONAME
+	pjmedia_port_destroy                     @ 97 NONAME
+	pjmedia_port_get_frame                   @ 98 NONAME
+	pjmedia_port_info_init                   @ 99 NONAME
+	pjmedia_port_put_frame                   @ 100 NONAME
+	pjmedia_resample_create                  @ 101 NONAME
+	pjmedia_resample_destroy                 @ 102 NONAME
+	pjmedia_resample_get_input_size          @ 103 NONAME
+	pjmedia_resample_port_create             @ 104 NONAME
+	pjmedia_resample_run                     @ 105 NONAME
+	pjmedia_rtcp_build_rtcp                  @ 106 NONAME
+	pjmedia_rtcp_fini                        @ 107 NONAME
+	pjmedia_rtcp_get_ntp_time                @ 108 NONAME
+	pjmedia_rtcp_init                        @ 109 NONAME
+	pjmedia_rtcp_rx_rtcp                     @ 110 NONAME
+	pjmedia_rtcp_rx_rtp                      @ 111 NONAME
+	pjmedia_rtcp_tx_rtp                      @ 112 NONAME
+	pjmedia_rtp_decode_rtp                   @ 113 NONAME
+	pjmedia_rtp_encode_rtp                   @ 114 NONAME
+	pjmedia_rtp_session_init                 @ 115 NONAME
+	pjmedia_rtp_session_update               @ 116 NONAME
+	pjmedia_session_check_dtmf               @ 117 NONAME
+	pjmedia_session_create                   @ 118 NONAME
+	pjmedia_session_destroy                  @ 119 NONAME
+	pjmedia_session_dial_dtmf                @ 120 NONAME
+	pjmedia_session_enum_streams             @ 121 NONAME
+	pjmedia_session_get_dtmf                 @ 122 NONAME
+	pjmedia_session_get_info                 @ 123 NONAME
+	pjmedia_session_get_port                 @ 124 NONAME
+	pjmedia_session_get_stream_stat          @ 125 NONAME
+	pjmedia_session_info_from_sdp            @ 126 NONAME
+	pjmedia_session_pause                    @ 127 NONAME
+	pjmedia_session_pause_stream             @ 128 NONAME
+	pjmedia_session_resume                   @ 129 NONAME
+	pjmedia_session_resume_stream            @ 130 NONAME
+	pjmedia_session_set_dtmf_callback        @ 131 NONAME
+	pjmedia_silence_det_apply                @ 132 NONAME
+	pjmedia_silence_det_create               @ 133 NONAME
+	pjmedia_silence_det_detect               @ 134 NONAME
+	pjmedia_silence_det_disable              @ 135 NONAME
+	pjmedia_silence_det_set_adaptive         @ 136 NONAME
+	pjmedia_silence_det_set_fixed            @ 137 NONAME
+	pjmedia_silence_det_set_name             @ 138 NONAME
+	pjmedia_silence_det_set_params           @ 139 NONAME
+	pjmedia_snd_port_connect                 @ 140 NONAME
+	pjmedia_snd_port_create                  @ 141 NONAME
+	pjmedia_snd_port_create_player           @ 142 NONAME
+	pjmedia_snd_port_create_rec              @ 143 NONAME
+	pjmedia_snd_port_destroy                 @ 144 NONAME
+	pjmedia_snd_port_disconnect              @ 145 NONAME
+	pjmedia_snd_port_get_ec_tail             @ 146 NONAME
+	pjmedia_snd_port_get_port                @ 147 NONAME
+	pjmedia_snd_port_get_snd_stream          @ 148 NONAME
+	pjmedia_snd_port_set_ec                  @ 149 NONAME
+	pjmedia_splitcomb_create                 @ 150 NONAME
+	pjmedia_splitcomb_create_rev_channel     @ 151 NONAME
+	pjmedia_splitcomb_set_channel            @ 152 NONAME
+	pjmedia_stream_check_dtmf                @ 153 NONAME
+	pjmedia_stream_create                    @ 154 NONAME
+	pjmedia_stream_destroy                   @ 155 NONAME
+	pjmedia_stream_dial_dtmf                 @ 156 NONAME
+	pjmedia_stream_get_dtmf                  @ 157 NONAME
+	pjmedia_stream_get_port                  @ 158 NONAME
+	pjmedia_stream_get_stat                  @ 159 NONAME
+	pjmedia_stream_get_transport             @ 160 NONAME
+	pjmedia_stream_info_from_sdp             @ 161 NONAME
+	pjmedia_stream_pause                     @ 162 NONAME
+	pjmedia_stream_resume                    @ 163 NONAME
+	pjmedia_stream_set_dtmf_callback         @ 164 NONAME
+	pjmedia_stream_start                     @ 165 NONAME
+	pjmedia_strerror                         @ 166 NONAME
+	pjmedia_tonegen_create                   @ 167 NONAME
+	pjmedia_tonegen_create2                  @ 168 NONAME
+	pjmedia_tonegen_get_digit_map            @ 169 NONAME
+	pjmedia_tonegen_is_busy                  @ 170 NONAME
+	pjmedia_tonegen_play                     @ 171 NONAME
+	pjmedia_tonegen_play_digits              @ 172 NONAME
+	pjmedia_tonegen_set_digit_map            @ 173 NONAME
+	pjmedia_tonegen_stop                     @ 174 NONAME
+	pjmedia_transport_udp_attach             @ 175 NONAME
+	pjmedia_transport_udp_close              @ 176 NONAME
+	pjmedia_transport_udp_create             @ 177 NONAME
+	pjmedia_transport_udp_create2            @ 178 NONAME
+	pjmedia_transport_udp_create3            @ 179 NONAME
+	pjmedia_transport_udp_get_info           @ 180 NONAME
+	pjmedia_transport_udp_simulate_lost      @ 181 NONAME
+	pjmedia_wav_player_port_create           @ 182 NONAME
+	pjmedia_wav_player_port_get_pos          @ 183 NONAME
+	pjmedia_wav_player_port_set_pos          @ 184 NONAME
+	pjmedia_wav_player_set_eof_cb            @ 185 NONAME
+	pjmedia_wav_playlist_create              @ 186 NONAME
+	pjmedia_wav_playlist_set_eof_cb          @ 187 NONAME
+	pjmedia_wav_writer_port_create           @ 188 NONAME
+	pjmedia_wav_writer_port_get_pos          @ 189 NONAME
+	pjmedia_wav_writer_port_set_cb           @ 190 NONAME
+	pjmedia_wave_hdr_file_to_host            @ 191 NONAME
+	pjmedia_wave_hdr_host_to_file            @ 192 NONAME
Index: pjproject/trunk/build.symbian/symbian_audioU.def
===================================================================
--- pjproject/trunk/build.symbian/symbian_audioU.def	(revision 1658)
+++ pjproject/trunk/build.symbian/symbian_audioU.def	(revision 1664)
@@ -8,4 +8,5 @@
 	pjmedia_snd_open_rec                     @ 7 NONAME
 	pjmedia_snd_stream_close                 @ 8 NONAME
-	pjmedia_snd_stream_start                 @ 9 NONAME
-	pjmedia_snd_stream_stop                  @ 10 NONAME
+	pjmedia_snd_stream_get_info              @ 9 NONAME
+	pjmedia_snd_stream_start                 @ 10 NONAME
+	pjmedia_snd_stream_stop                  @ 11 NONAME